header "util"
/{ 

 extern int irq2minormap[];

 #define MAX_BUFS 16
 #define MAX_BUFSIZE 32

 #define BUF_EMPTY    0
 #define BUF_OK       1
 #define BUF_OVERRUN  2
 #define BUF_UNDERRUN 3

 typedef struct {
	int head;
        int tail;
        int status;
	int active;
        canmsg_t data[MAX_BUFSIZE];
 } msg_fifo_t;

 extern msg_fifo_t Tx_Buf[];
 extern msg_fifo_t Rx_Buf[];

 extern int Can_RequestIrq(int minor, int irq, void (*handler)());
 extern struct wait_queue *CanWait[];

}/

file "util" /{
 
 int irq2minormap[15];
 struct wait_queue *CanWait[MAX_BUFS];

 msg_fifo_t Tx_Buf[MAX_BUFS];
 msg_fifo_t Rx_Buf[MAX_BUFS];
 


 int Can_RequestIrq(int minor, int irq, void (*handler)()) {
	int err=0;
	DBGin("Can_RequestIrq");
	err = request_irq( irq, handler, SA_INTERRUPT, "%<driver.name>", NULL );
	if( !err )
	  irq2minormap[irq] = minor;
	DBGout();return err;
 }

 int Can_FreeIrq( int irq ) {
	DBGin("Can_FreeIrq");
	free_irq(irq,NULL);
	DBGout();
 }

 int Can_WaitInit(int minor) {
	int i;
	DBGin("Can_WaitInit");
		CanWait[minor] = NULL;
	DBGout();
 }

 int Can_FifoInit(int minor) {
	DBGin("Can_FifoInit");
	   Tx_Buf[minor].head   = Rx_Buf[minor].head = 0;
	   Tx_Buf[minor].tail   = Rx_Buf[minor].tail = 0;
	   Tx_Buf[minor].status = Rx_Buf[minor].status = 0;
	   Tx_Buf[minor].active = Rx_Buf[minor].active = 0;
	DBGout();
 }



}/



